#!/bin/bash

## user specified settings
DATA_DIR="data"
NET_FILE1="kshv-network.txt"
NET_FILE2="vzv-network.txt"
NODE_FILE1="kshv-node.txt"
NODE_FILE2="vzv-node.txt"
ORTH_FILE="ortholog.txt"
OUTPUT_DIR="results"
BIN_DIR="../bin"
BIN="binaligner"
LOG_FILE="log"

## run BINAligner
${BIN_DIR}/${BIN} --net1-file      ${DATA_DIR}/${NET_FILE1}      \
                  --net2-file      ${DATA_DIR}/${NET_FILE2}      \
                  --node1-file     ${DATA_DIR}/${NODE_FILE1}     \
                  --node2-file     ${DATA_DIR}/${NODE_FILE2}     \
                  --orth-file      ${DATA_DIR}/${ORTH_FILE}      \
                  --output-dir     ${OUTPUT_DIR}                 \
                  --lambda         0.5                           \
                  --graphlet-coef  0.08                          \
                  --orth-coef      0.9                           \
                  --alpha          1.6                           \
                  --beta           -0.3                          \
                  --gamma          4.4                           \
                  --delta          -1.6


