/*
 * cplexalign.h
 *
 * Copyright 2011-2012. All rights reserved.
 */

#ifndef JL_CPLEXALIGN_H_
#define JL_CPLEXALIGN_H_ 1


#include <ilcplex/ilocplex.h>
#include <sys/timeb.h>
#include "subnetwork.h"
#include "similaritymatrix.h"



int CplexSubILPAlign(SubNetwork&       hSubNetwork,
                     SubNetwork&       gSubNetwork,
                     SimilarityMatrix& inSimMatrix,
                     SimilarityMatrix& outSimMatrix,
                     bool              lowDegree);

int CplexGlobalILPAlign(Network&                  hNetwork,
                        Network&                  gNetwork,
                        SimilarityMatrix&         simMatrix,
                        int**                     finalSimMatrix,
                        std::vector<std::string>* vAlignmentNodeStr,
                        float                     maxAssignmentScore);

int CplexAssignmentILPAlign(Network&                  hNetwork,
                            Network&                  gNetwork,
                            int**                     simMatrix,
                            std::vector<std::string>* vAlignmentNodeStr,
                            float&                    maxAssignmentScore);

int IsoAlign(Network&,
             Network&,
             int,
             int,
             SimilarityMatrix&,
             SimilarityMatrix&);

int IsoAlign(Network&,
             Network&,
             SubNetwork&,
             int,
             SimilarityMatrix&,
             SimilarityMatrix&);

int IsoAlign(Network&,
             Network&,
             int,
             SubNetwork&,
             SimilarityMatrix&,
             SimilarityMatrix&);


#endif //JL_CPLEXALIGN_H_
