/*
 * extern.h
 *
 * Copyright 2011-2012. All rights reserved.
 */

#ifndef JL_EXTERN_H_
#define JL_EXTERN_H_ 1

#include "similaritymatrix.h"
#include <vector>

int GetFinalSimMatrix(int**               finalSimMatrix,
                      SimilarityMatrix&   simMatrix,
                      float***            simDensNMatrix,
                      float***            edgeDiffNMatrix,
                      float               fSimMatrixParam,
                      std::vector<float>& vSimDensParam,
                      std::vector<float>& vEdgeDiffParam,
                      int                 n);

int GetFixedVar(Network&          hNetwork,
                Network&          gNetwork,
                std::vector<int>* fixedVarIntList,
                const char*       alignmentFile);

int RemoveNegContributionAlignedPairs(Network&                  hNetwork,
                                      Network&                  gNetwork,
                                      SimilarityMatrix&         simMatrix,
                                      std::vector<std::string>* vAlignmentNodeStr,
                                      std::vector<std::string>* posContribAlignedPairs);

int GetFixedVar(Network&                  hNetwork,
                Network&                  gNetwork,
                std::vector<std::string>* vAlignmentNodeStr,
                const char*               alignmentFile);

int PrintAlignmentInfo(Network&                  hNetwork,
                       Network&                  gNetwork,
                       SimilarityMatrix&         similarityMatrix,
                       std::vector<std::string>* vAlignmentNodeStr);

int GetFinalSimMatrix(float**           finalSimMatrix,
                      SimilarityMatrix& simMatrix,
                      float**           simGraphletMatrix,
                      float             coefSimGraphlet);

int GetFinalSimMatrix(float**           finalSimMatrix,
                      SimilarityMatrix& oriSimMatrix,
                      SimilarityMatrix& neiSimMatrix,
                      float**           simGraphletMatrix);

int GetFinalSimMatrix(int**             finalSimMatrix,
                      SimilarityMatrix& simMatrix,
                      float**           simGraphletMatrix,
                      float             coefSimGraphlet);

int GetFinalSimMatrix(int**             finalSimMatrix,
                      SimilarityMatrix& oriSimMatrix,
                      SimilarityMatrix& neiSimMatrix,
                      float**           simGraphletMatrix);

int GetFinalSimMatrix(int**             finalSimMatrix,
                      SimilarityMatrix& simMatrix);
void GenerateAlignmentFile(Network&                   hNetwork,
                           Network&                   gNetwork,
                           const char*                alignmentFile,
                           std::vector<std::string>*  vAlignmentNodeStr,
                           SimilarityMatrix&          simMatrix);

#endif // JL_EXTERN_H_
