/*
 * graphlet.cpp
 *
 * Copyright 2011-2012. All rights reserved.
 */

#include <cstdlib>
#include "graphlet.h"

using namespace std;

Graphlet::Graphlet() :
vGraphletPattern()
{
}

Graphlet::~Graphlet()
{
}

int Graphlet::Sort2Node(int& n1, int& n2)
{
    if (n1 > n2)
    {
        char tmp = n1;
        n1 = n2;
        n2 = tmp;
    }
    return 0;
}
int Graphlet::SortPatternString(vector<int>& vPattern, int patternType)
{
    if (patternType == 1)
    {
        Sort2Node(vPattern[0], vPattern[2]);
    }
    else if (patternType == 2)
    {
        Sort2Node(vPattern[1], vPattern[2]);
    }
    else if (patternType == 11)
    {
        Sort2Node(vPattern[1], vPattern[3]);
    }
    else if (patternType == 7)
    {
        Sort2Node(vPattern[1], vPattern[3]);
    }
    else if (patternType == 5)
    {
        Sort2Node(vPattern[2], vPattern[3]);
    }
    else if (patternType == 8)
    {
        Sort2Node(vPattern[2], vPattern[3]);
    }
    else if (patternType == 6 || patternType == 13)
    {
        Sort2Node(vPattern[2], vPattern[3]);
        Sort2Node(vPattern[1], vPattern[2]);
        Sort2Node(vPattern[2], vPattern[3]);
    }
    else if (patternType == 10)
    {
        Sort2Node(vPattern[2], vPattern[3]);
    }
    else if (patternType == 12)
    {
        Sort2Node(vPattern[1], vPattern[2]);
    }
    return 0;
}
int Graphlet::getGraphlet(Network& network, int iNode)
{
    int iCenterLinkedIndex = network.GetLinkedNodeIndex(iNode);
//  2 nodes to 3 nodes
    vector<int> vTmp(3,-1);
    int node0 = iCenterLinkedIndex;
    int node1, node2, node3;

    for (int i = 0; i < network.netIntNeighborVec[node0].size(); i++)
    {
        //pattern 0
        for (int j = 0; j < network.netIntNeighborVec[network.netIntNeighborVec[node0][i]].size(); j++)
        {
            node1 = network.netIntNeighborVec[node0][i];
            node2 = network.netIntNeighborVec[node1][j];

            if (node0 != node2)
            {
                vTmp[0] = node0;
                vTmp[1] = node1;
                vTmp[2] = node2;
                if (network.netMatrix[node2][node0] == 0)
                {
                    InsertPattern(vGraphletPattern[0], vTmp);
                }
            }
        }

        //pattern 1 & 2
        for (int k = i+1; k < network.netIntNeighborVec[node0].size(); k++)
        {
            node1 = network.netIntNeighborVec[node0][i];
            node2 = network.netIntNeighborVec[node0][k];

            if ( network.netMatrix[node1][node2] == 0)
            {
                vTmp[0] = node1;
                vTmp[1] = node0;
                vTmp[2] = node2;
                SortPatternString(vTmp, 1);
                InsertPattern(vGraphletPattern[1], vTmp);
            }
            else
            {
                vTmp[0] = node0;
                vTmp[1] = node1;
                vTmp[2] = node2;
                SortPatternString(vTmp, 2);
                InsertPattern(vGraphletPattern[2], vTmp);
            }
        }
    }

    // 3 nodes to 4 nodes
    vTmp.push_back(-1);
    //pattern 0 -> 3,4,5,6,7,8,9,11
    for (int i = 0; i < vGraphletPattern[0].size(); i++)
    {
        node0 = vGraphletPattern[0][i][0];
        node1 = vGraphletPattern[0][i][1];
        node2 = vGraphletPattern[0][i][2];

        // new node coming out of node0
        for (int j = 0; j < network.netIntNeighborVec[node0].size(); j++)
        {
            node3 = network.netIntNeighborVec[node0][j];
            if (node3 != node1 && node3 != node2)
            {
                if (network.netMatrix[node3][node1] == 1 && network.netMatrix[node3][node2] == 0)
                {
                    vTmp[0] = node0;
                    vTmp[1] = node3;
                    vTmp[2] = node1;
                    vTmp[3] = node2;
                    InsertPattern(vGraphletPattern[9], vTmp);
                }
                else if (network.netMatrix[node3][node1] == 1 && network.netMatrix[node3][node2] == 1)
                {
                    vTmp[0] = node0;
                    vTmp[1] = node3;
                    vTmp[2] = node2;
                    vTmp[3] = node1;
                    SortPatternString(vTmp, 11);
                    InsertPattern(vGraphletPattern[11], vTmp);
                }
                else if (network.netMatrix[node3][node1] == 0 && network.netMatrix[node3][node2] == 1)
                {
                    vTmp[0] = node0;
                    vTmp[1] = node3;
                    vTmp[2] = node2;
                    vTmp[3] = node1;
                    SortPatternString(vTmp, 7);
                    InsertPattern(vGraphletPattern[7], vTmp);
                }
                else if (network.netMatrix[node3][node1] == 0 && network.netMatrix[node3][node2] == 0)
                {
                    vTmp[0] = node3;
                    vTmp[1] = node0;
                    vTmp[2] = node1;
                    vTmp[3] = node2;
                    InsertPattern(vGraphletPattern[4], vTmp);
                }
            }
        }
        //new node coming out of node1
        for (int j = 0; j < network.netIntNeighborVec[node1].size(); j++)
        {
            node3 = network.netIntNeighborVec[node1][j];
            if (node3 != node0 && node3 != node2)
            {
                if (network.netMatrix[node3][node0] == 0 && network.netMatrix[node3][node2] == 0)
                {
                    vTmp[0] = node0;
                    vTmp[1] = node1;
                    vTmp[2] = node2;
                    vTmp[3] = node3;
                    SortPatternString(vTmp, 5);
                    InsertPattern(vGraphletPattern[5], vTmp);
                }
                else if (network.netMatrix[node3][node0] == 0 && network.netMatrix[node3][node2] == 1)
                {
                    vTmp[0] = node0;
                    vTmp[1] = node1;
                    vTmp[2] = node2;
                    vTmp[3] = node3;
                    SortPatternString(vTmp, 8);
                    InsertPattern(vGraphletPattern[8], vTmp);
                }
            }
        }
        //new node coming out of node2
        for (int j = 0; j < network.netIntNeighborVec[node2].size(); j++)
        {
            node3 = network.netIntNeighborVec[node2][j];
            if (node3 != node1 && node3 != node0 && network.netMatrix[node3][node0] == 0 && network.netMatrix[node3][node1] == 0)
            {
                vTmp[0] = node0;
                vTmp[1] = node1;
                vTmp[2] = node2;
                vTmp[3] = node3;
                InsertPattern(vGraphletPattern[3], vTmp);
            }
        }
    }

    //pattern 1 -> 6,10,12
    for (int i = 0; i < vGraphletPattern[1].size(); i++)
    {
        node0 = vGraphletPattern[1][i][1];
        node1 = vGraphletPattern[1][i][0];
        node2 = vGraphletPattern[1][i][2];
        for (int j = 0; j < network.netIntNeighborVec[node0].size(); j++)
        {
            node3 = network.netIntNeighborVec[node0][j];
            if (node3 != node1 && node3 != node2)
            {
                if (network.netMatrix[node3][node1] == 0 && network.netMatrix[node3][node2] == 0)
                {
                    vTmp[0] = node0;
                    vTmp[1] = node1;
                    vTmp[2] = node2;
                    vTmp[3] = node3;
                    SortPatternString(vTmp, 6);
                    InsertPattern(vGraphletPattern[6], vTmp);
                }
                else if (network.netMatrix[node3][node1] == 0 && network.netMatrix[node3][node2] == 1)
                {
                    vTmp[0] = node1;
                    vTmp[1] = node0;
                    vTmp[2] = node2;
                    vTmp[3] = node3;
                    SortPatternString(vTmp, 10);
                    InsertPattern(vGraphletPattern[10], vTmp);
                }
                else if (network.netMatrix[node3][node1] == 1 && network.netMatrix[node3][node2] == 0)
                {
                    vTmp[0] = node2;
                    vTmp[1] = node0;
                    vTmp[2] = node1;
                    vTmp[3] = node3;
                    SortPatternString(vTmp, 10);
                    InsertPattern(vGraphletPattern[10], vTmp);
                }
                else if (network.netMatrix[node3][node1] == 1 && network.netMatrix[node3][node2] == 1)
                {
                    vTmp[0] = node0;
                    vTmp[1] = node1;
                    vTmp[2] = node3;
                    vTmp[3] = node2;
                    SortPatternString(vTmp, 12);
                    InsertPattern(vGraphletPattern[12], vTmp);
                }
            }
        }

    }

    //pattern 2 -> 13
    for (int i = 0; i < vGraphletPattern[2].size(); i++)
    {
        node0 = vGraphletPattern[2][i][0];
        node1 = vGraphletPattern[2][i][1];
        node2 = vGraphletPattern[2][i][2];
        for (int j = 0; j < network.netIntNeighborVec[node0].size(); j++)
        {
            node3 = network.netIntNeighborVec[node0][j];
            int test = 0;
            if (node3 != node1 && node3 != node2)
            {
                for (int k = 0; k < network.netIntNeighborVec[node3].size(); k++)
                {
                    if (network.netIntNeighborVec[node3][k] == node1)
                    {
                        test += 1;
                    }
                    if (network.netIntNeighborVec[node3][k] == node2)
                    {
                        test += 1;
                    }
                    if (test == 2)
                    {
                        vTmp[0] = node0;
                        vTmp[1] = node1;
                        vTmp[2] = node2;
                        vTmp[3] = node3;
                        SortPatternString(vTmp, 13);
                        InsertPattern(vGraphletPattern[13], vTmp);
                        break;
                    }
                }
            }
        }
    }

    return 0;
}

int Graphlet::InsertPattern(vector<vector<int> >& vGraphletPattern, vector<int>& vTmp)
{
    int i,j;
    bool identityTest = 0;
    for (i = 0; i < vGraphletPattern.size(); i++)
    {
        if (vGraphletPattern[i].size() != vTmp.size())
        {
            cerr << "The sizes of two vectors are not equal!" << endl;
            exit(-1);
        }
        for (j = 0; j < vGraphletPattern[i].size(); j++)
        {
            if (vGraphletPattern[i][j] != vTmp[j])
            {
                break;
            }
        }
        if (j == vGraphletPattern[i].size())
        {
            identityTest = 1;
            break;
        }
    }
    if (identityTest == 0)
    {
        vGraphletPattern.push_back(vTmp);
    }
    return 0;
}

int Graphlet::PrintVGraphletPattern()
{
    for (int i = 0; i < NPATTERN; i++)
    {
        cout << "++ " << i << " : " << vGraphletPattern[i].size() << endl;
        for (int j = 0; j < vGraphletPattern[i].size(); j++)
        {
            for (int k = 0; k < vGraphletPattern[i][j].size(); k++)
            {
                cout << vGraphletPattern[i][j][k] << " ";
            }
            cout << endl;
        }
    }
    return 0;
}

