/*
 * subnetwork.cpp
 *
 * Copyright 2011-2012. All rights reserved.
 */


#include "subnetwork.h"

using namespace std;

SubNetwork::SubNetwork() :
nNode(0),
nEdge(0),
centerNode(0),
nLoop(0),
netMatrix(NULL)
{
}


SubNetwork::~SubNetwork()
{
    for(int i = 0; i < nNode - 1; i++)
    {
        delete[] netMatrix[i];
        netMatrix[i] = NULL;
    }
    delete[] netMatrix;
    netMatrix = NULL;
}

int SubNetwork::GetNetIndex(int subNetIndex)
{
    return nodeIntVec[subNetIndex];
}

int SubNetwork::PrintNetMatrix()
{
    for (int i = 0; i < nNode - 1; i++)
    {
        for (int j = 0; j < nNode - 1; j++)
        {
            cout << netMatrix[i][j];
            if (j < nNode - 1) cout << " ";
        }
        cout << endl;
    }
    return 0;
}

int SubNetwork::PrintNetIntVec()
{
    for (size_t i = 0; i < netIntVec[0].size(); i++)
    {
        cout << netIntVec[0][i] << " " << netIntVec[1][i] << endl;
    }
    return 0;
}

int SubNetwork::PrintNodeIntVec()
{
    for (int i = 0; i < nNode - 1; i++)
    {
        cout << nodeIntVec[i] << endl;
    }
    return 0;
}

int SubNetwork::PrintNodeStrVec()
{
    cout << "index\tnodeStr" << endl;
    for (int i = 0; i < nNode -1; i++)
    {
        cout << i << "\t" << nodeStrVec[i] << endl;
    }
    return 0;
}

int SubNetwork::PrintNetStrVec()
{
    for (int i = 0; i < nEdge - nNode + 1; i++)
    {
        string net1, net2;

        net1 = nodeStrVec[netIntVec[0][i]];
        net2 = nodeStrVec[netIntVec[1][i]];
        cout << net1 << " " << net2 << endl;
    }
    return 0;
}

int SubNetwork::PrintNodeMap()
{
    for (map<int, int>::iterator itr = nodeMap.begin(); itr != nodeMap.end(); itr++)
    {
        cout << itr->first << " --> " << itr->second << endl;
    }
    return 0;
}
